Unit A_GRF;

interface
  uses Graph;

Type
  TImgRec = record
               sx,sy   : word;
               DATA    : array[1..64000] of byte;
            end;

Const
  A_CopyPut = False;
  A_MaskPut = True;
  VGA       = $a000;

var
 VisualScr    : Pointer;
 VSAddr       : Word;

procedure InitMCGA;
procedure Flip;
procedure YPutImage(P : Pointer; x,y : integer; mask : boolean; mc : byte);
function  YGetImage(var P : Pointer; x,y,x1,y1 : integer) : Word;
procedure ConvertIMG(var P : Pointer; CNot, C : byte);
function  GetSize(P : Pointer) : Word;
procedure PutImagePix(P : Pointer; x,y,c1,c2,Addr : word);
procedure NPutImagePix(P : Pointer; x,y,c1, Addr : word);
procedure PutPixel(x,y,c,Addr : word);
procedure SFlip(source,dest:Word);
Procedure Cls (Col : Byte; Where:word);
Procedure SetVisScr;
procedure WaitRetrace;
procedure VBar(x,y,x2,y2 : WORD; c : BYTE; where : WORD);
Procedure NPutImage(x,y : word; VAR img; Where : word);
Procedure ScreenTrans(x,y:word;sx, sy : word; FromS, ToS : word);
Procedure PutIMG(IMG : Pointer; x,y,w,h : integer; Addr : Word);
Procedure GetIMG(var IMG : Pointer; x,y,w,h : integer; Addr : Word);
Procedure SaveIMG(IMG : Pointer; h,w : integer; fn : string);
Procedure LoadIMG(var IMG : Pointer; h,w : integer; fn : string);
          {Screen Transaction}
implementation

procedure InitMCGA;
begin
   asm
     mov ax, 13h;
     int 10h;
   end;
end;

Procedure PutIMG(IMG : Pointer; x,y,w,h : integer; Addr : Word);
var
 Segm, Ofss : Word;
 DPos       : Word;
 i          : integer;
begin
   Segm := Seg(IMG^);
   Ofss := Ofs(IMG^);
   DPos := y*320+x;
   for i := 1 to h do
   begin
      move(mem[Segm:Ofss],mem[Addr:DPos],w);
      inc(DPos,320);
      inc(Ofss,w);
   end;
end;

Procedure GetIMG(var IMG : Pointer; x,y,w,h : integer; Addr : Word);
var
 Segm, Ofss : Word;
 DPos       : Word;
 i          : integer;
begin
   GetMem(IMG,w*h);
   Segm := Seg(IMG^);
   Ofss := Ofs(IMG^);
   DPos := y*320+x;
   for i := 1 to h do
   begin
      move(mem[Addr:DPos],mem[Segm:Ofss],w);
      inc(DPos,320);
      inc(Ofss,w);
   end;
end;

Procedure SaveIMG(IMG : Pointer; h,w : integer; fn : string);
var
 f : file;
begin
   Assign(F,fn);
   ReWrite(F,1);
   BlockWrite(F,IMG^,h*w);
   Close(F);
end;

Procedure LoadIMG(var IMG : Pointer; h,w : integer; fn : string);
var
 f : file;
begin
   Assign(F,fn);
   ReSet(F,1);
   GetMem(IMG,h*w);
   BlockRead(F,IMG^,h*w);
   Close(F);
end;


Procedure PutPixel(x,y,c,Addr : word);
var
 i : word;
begin
   if X > 319 then exit;
   if Y > 200 then exit;
   if X < 0 then exit;
   if Y < 1 then exit;

   I := X+((Y-1)*320);
   mem[Addr:I] := C;
end;

Procedure YPutImage(P : Pointer; x,y : integer; mask : boolean; mc : byte);
var
 DataComp : Pointer;
 sx,sy, i : integer;
begin
   if mask then
   begin
      sx := TImgRec(P^).sx;
      sy := TImgRec(P^).sy;
      YGetImage(DataComp,x,y,x+sx,y+sy);
      for i := 1 to (sx+1)*(sy+1) do
        if (TImgRec(P^).data[i] <> mc) then
         TImgRec(DataComp^).data[i] := TImgRec(P^).data[i];
      PutImage(x,y,DataComp^,CopyPut);
      FreeMem(DataComp,GetSize(DataComp));
   end
  else
   PutImage(x,y,P^,CopyPut);
end;

Function YGetImage(var P : Pointer; x,y,x1,y1 : integer) : Word;
var
 Size : Word;
begin
   Size := ((x1-x)+1)*((y1-y)+1)+4;
   GetMem(P,Size);
   GetImage(x,y,x1,y1,P^);
   YGetImage := Size;
end;

Procedure ConvertIMG(var P : Pointer; CNot, C : byte);
var
 sx, sy : word;
 i      : integer;
begin
   sx := TImgRec(P^).sx+1;
   sy := TImgRec(P^).sy+1;
   for i := 1 to (sx*sy) do
     if TImgRec(P^).DATA[i] <> CNot then
        TImgRec(P^).DATA[i] := C;
end;

Function GetSize(P : Pointer) : Word;
begin
   GetSize := 4+((TImgRec(P^).sx+1)*(TImgRec(P^).sy+1));
end;

Procedure PutImagePix(P : Pointer; x,y,c1,c2,Addr : word);
var
 xx,yy, i : word;
begin
   xx := x;
   yy := y;
   for i := 1 to (TImgREC(P^).sx+1)*(TImgREC(P^).sy+1) do
   begin
      if TImgREC(P^).DATA[i] <> c2 then
        PutPixel(xx,yy,c1,Addr);
      if xx-x >= TImgREC(P^).SX then
      begin
        xx := x;
        inc(yy);
      end
     else
      inc(xx);
   end;
end;


Procedure NPutImagePix(P : Pointer; x,y,c1, Addr : word);
var
 xx,yy, i : word;
begin
   xx := x;
   yy := y;
   for i := 1 to (TImgREC(P^).sx+1)*(TImgREC(P^).sy+1) do
   begin
      if TImgREC(P^).DATA[i] <> c1 then
        PutPixel(xx,yy,TImgREC(P^).DATA[i], Addr);
      if xx-x >= TImgREC(P^).SX then
      begin
        xx := x;
        inc(yy);
      end
     else
      inc(xx);
   end;
end;

procedure SFlip(source,dest:Word);
  { This copies the entire screen at "source" to destination }
begin
  asm
    push    ds
    mov     ax, [Dest]
    mov     es, ax
    mov     ax, [Source]
    mov     ds, ax
    xor     si, si
    xor     di, di
    mov     cx, 32000
    rep     movsw
    pop     ds
  end;
end;

Procedure Cls(Col : Byte; Where : Word);
begin
{     asm
        push    es
        mov     cx, 32000;
        mov     es,[where]
        xor     di,di
        mov     al,[col]
        mov     ah,al
        rep     stosw
        pop     es
     End;   }
   FillChar(mem[Where:0],64000,Col);
end;


Procedure Flip;
begin
{  Move(VisualScr^,mem[$a000:0], 64000);}
   SFlip(VSAddr,VGA);
end;

procedure WaitRetrace; assembler;
  { This waits until you are in a Verticle Retrace ... this means that all
    screen manipulation you do only appears on screen in the next verticle
    retrace ... this removes most of the "fuzz" that you see on the screen
    when changing the pallette. It unfortunately slows down your program
    by "synching" your program with your monitor card ... it does mean
    that the program will run at almost the same speed on different
    speeds of computers which have similar monitors. In our SilkyDemo,
    we used a WaitRetrace, and it therefore runs at the same (fairly
    fast) speed when Turbo is on or off. }

label
  l1, l2;
asm
    mov dx,3DAh
l1:
    in al,dx
    and al,08h
    jnz l1
l2:
    in al,dx
    and al,08h
    jz  l2
end;

Procedure SetVisScr;
begin
   GetMem(VisualScr,64000);
   VSAddr := Seg(VisualScr^);
end;

PROCEDURE VBar(x,y,x2,y2 : WORD; c : BYTE; where : WORD);
  { Draws a filled bar to where segment}
VAR pmo,py : WORD;
BEGIN
     pmo:=y shl 8+y shl 6+x;

     x2:=x2-x+1;
     y2:=y2-y;

     FOR py:=0 TO y2 DO
     BEGIN
          fillchar(mem[where:pmo],x2,c);
          inc(pmo,320);
     END;
END;

Procedure PutSprite(X,Y : Word; Width, Height : Byte; VAR sprt; Where:Word); ASSEMBLER;
  { This puts an icon, EXCEPT it's color 0 (black) pixels, onto the screen
    "where", at position X,Y }
label
  _Redraw, _DrawLoop, _Exit, _LineLoop, _NextLine, _Store, _NoPaint;

asm
    push  ds
    push  es
    lds   si,Sprt
    mov   ax,X     { ax = x }
    mov   bx,Y     { bx = y }
_Redraw:
    push    ax
    mov     ax,[where]
    mov     es,ax

    mov     ax, bx                  {; ax = bx  x = y}
    mov     bh, bl                  {; y = y * 256  bx = bx * 256}
    xor     bl, bl
    shl     ax, 1
    shl     ax, 1
    shl     ax, 1
    shl     ax, 1
    shl     ax, 1
    shl     ax, 1                   {; y = y * 64   ax = ax * 64}
    add     bx, ax                  {; y = (y*256) + (Y*64)  bx = bx + ax (ie y*320)}

    pop     ax                      {; get back our x}


    add     ax, bx                  {; finalise location}
    mov     di, ax

    mov   dl,Height    { dl = height of sprite }
    xor   ch,ch
    mov   cl,Width     { cx = width of sprite }
    cld
    push  ax
    mov   ax,cx
_DrawLoop:
    push  di            { store y adr. for later }
    mov   cx,ax          { store width }
_LineLoop:
    mov   bl,byte ptr [si]
    or    bl,bl
    jnz   _Store
_NoPaint:
    inc    si
    inc    di
    loop   _LineLoop
    jmp    _NextLine
_Store:
    movsb
    loop  _LineLoop
_NextLine:
    pop   di
    dec   dl
    jz    _Exit
    add   di,320        { di = next line of sprite }
    jmp   _DrawLoop
_Exit:
    pop   ax
    pop   es
    pop   ds
end;

Procedure _ScreenTrans (x,y:word;sx, sy, VV : word; FromS, ToS : word);
  { This is a small procedure to copy a 30x30 pixel block from coordinates
    x,y on the virtual screen to coordinates x,y on the true vga screen }
BEGIN
  asm
    push    ds
    push    es
    mov     ax,ToS
    mov     es,ax
    mov     ax,FromS
    mov     ds,ax
    mov     bx,[X]
    mov     dx,[Y]
    push    bx                      {; and this again for later}
    mov     bx, dx                  {; bx = dx}
    mov     dh, dl                  {; dx = dx * 256}
    xor     dl, dl
    shl     bx, 1
    shl     bx, 1
    shl     bx, 1
    shl     bx, 1
    shl     bx, 1
    shl     bx, 1                   {; bx = bx * 64}
    add     dx, bx                  {; dx = dx + bx (ie y*320)}
    pop     bx                      {; get back our x}
    add     bx, dx                  {; finalise location}
    mov     di, bx                  {; es:di = where to go}
    mov     si, di
    mov     al,60
    mov     bx, sy         { Hight of block to copy }
@@1 :
    mov     cx, sx         { Width of block to copy divided by 2 }
    rep     movsw
    add     di,VV        { 320 - 48 = 272 .. or 110 in hex }
    add     si,VV
    dec     bx
    jnz     @@1

    pop     es
    pop     ds
  end;
END;

Procedure ScreenTrans(x,y:word;sx, sy : word; FromS, ToS : word);
begin
   _ScreenTrans(x,y,sx div 2,sy,320-sx,FromS,ToS);
end;

Procedure NPutImage(x,y : word; VAR img; Where : word);
begin
   PutSprite(x,y,TImgREC(IMG).SX+1,TImgREC(IMG).SY+1,TImgREC(Img).DATA,Where);
end;


begin
end.