unit BmpSVGA;

interface
  uses Crt, A_Grf;

type
  BMP_Pal   = ARRAY[0..255,1..4] OF Byte;

Procedure PutSpriteLine(x,y : integer; var p : pointer; j : integer; Addr : word);
Procedure PutSprite(x,y : integer; var p : pointer; Addr: Word);
Procedure LoadBmp(Fn : string; var P : Pointer);
Procedure Pal(Col,R,G,B : Byte);
Procedure GetPal(Col : Byte; var R,G,B : Byte);
Procedure SaveScreen(Fn : string);
Procedure ConvSprite(x,y : integer; var p : pointer);
Procedure Set_BMP_Pal(RGB : BMP_Pal);

Const
  BmpH : Array[0..53] of Byte =
  ($42,$4D,$36,$FE,$00,$00,$00,$00,$00,$00,
   $36,$04,$00,$00,$28,$00,$00,$00,$40,$01,
   $00,$00,$C8,$00,$00,$00,$01,$00,$08,$00,
   $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,
   $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,
   $00,$00,$00,$00);


implementation

Procedure PutSpriteLine(x,y : integer; var p : pointer; j : integer; Addr: word);
var
  i : integer;
  sg, off : word;
  B       : Byte;
begin
   sg := seg(P^);
   off := ofs(P^);
{   for i := 0 to 319 do
   begin
      PutPixel(x+i,y+(200-j),mem[sg:off+(j*320)+i],Addr);
   end;}
   move(mem[sg:off+(j*320)],mem[Addr:(y+(200-j))*320],320);
end;

Procedure PutSprite(x,y : integer; var p : pointer; Addr : word);
var
  j : integer;
begin
   for j := 199 downto 0 do
     PutSpriteLine(x,y, P,J,Addr);
end;

Procedure ConvSLine(x,y : integer; var p : pointer; j : integer);
var
  i, ii : integer;
  sg, off : word;
  B     : Byte;
  _r,_g,_b : byte;
  r2,g2,b2 : byte;
  c : longint;
  s : string;
begin
   sg := seg(P^);
   off := ofs(P^);
   c := 0;
   for i := 1 to 320 do
   begin
      B := mem[sg:off+(j*320)+i];
      if b < 15 then
        inc(C);
   {   GetPal(B,_r,_g,_b);
      for ii := 0 to 15 do
      begin
         GetPal(ii,r2, g2, b2);
         if (r2 = _r) and (g2 = _g) and (b2 = _b) then
            mem[sg:off+(j*320)+i] := ii;
      end;  }
   end;
   str(C,S);
end;

Procedure ConvSprite(x,y : integer; var p : pointer);
var
  j : integer;
begin
   for j := 200 downto 1 do
     ConvSLine(x,y, P,J);
end;


Procedure Pal(Col,R,G,B : Byte);
{Setting SVGA RGB palette}
begin
     Port[$3c8]:=Col;

     Port[$3c9]:=r;
     Port[$3c9]:=g;
     Port[$3c9]:=b;
end;

Procedure GetPal(Col : Byte; var R,G,B : Byte);
{Getting SVGA RGB palette}
begin
   Port[$3c7]:=Col;

   r:=Port[$3c9];
   g:=Port[$3c9];
   b:=Port[$3c9];
end;


Procedure Set_BMP_Pal(RGB : BMP_Pal);
var
 I : Integer;
Begin
   for i := 0 to 255 do
     Pal(I,RGB[I,3] div 4,RGB[I,2] div 4,RGB[I,1] div 4);
End;

Procedure Get_BMP_Pal(var RGB : BMP_Pal);
var
 I : Integer;
Begin
   for i := 0 to 255 do
   begin
      GetPal(I,RGB[I,3],RGB[I,2],RGB[I,1]);
      RGB[I,3] := RGB[I,3] * 4;
      RGB[I,2] := RGB[I,2] * 4;
      RGB[I,1] := RGB[I,1] * 4;
   end;
End;


Procedure LoadBmp(Fn : string; var P : Pointer);
var
 Header : array[0..53] of byte;
 Pl     : BMP_Pal;
 F      : file;
begin
   Assign(F,FN);
   Reset(F,1);
   Blockread(F,Header,sizeof(header));
   Blockread(F,pl,sizeof(pl));
   getmem(P, 64000);
   BlockRead(F, P^, 64000);
{   Set_Bmp_pal(pl);}
   freemem(P, 64000);
   close(F);
   pal(0,0,0,0);
end;

Procedure SaveScreen(Fn : string);
var
 Pl     : BMP_Pal;
 F      : file;
begin
   Assign(F,FN);
   ReWrite(F,1);
   BlockWrite(F,BmpH,sizeof(BmpH));
   Get_Bmp_Pal(pl);
   BlockWrite(F,pl,sizeof(pl));
   BlockWrite(F, Mem[$A000:0], 64000);
   Close(F);
end;


end.