unit Music_U;

interface

uses crt;

Const
  Nums  : set of char = ['0'..'9'];
  Notes : set of char = ['A'..'G'];
  Signs : set of char = ['<','>','|'];
  NotesValues : array['A'..'G'] of Byte = (10,12,1,3,5,6,8);

Type
 MusicREC = record
              Size : Word;
              DATA : Array[1..65533] of CHAR;
            end;

 Note_REC = record
               Freq : word;
               D    : word;
            end;

 Mus_REC  = record
               DATA : Array[1..256] of Note_REC;
               Count : word;
            end;

 MPlayer = Object
              Music   : Mus_REC;
              Playing : boolean;
              Counter : word;
              Timer   : word;
              Procedure UpDate;
              Procedure Play(s : string);
           end;


implementation
var
 Brk : Word;

Function GetTone(T : integer) : integer;
const
 Step = 1.05946309445;
var
 Tone : integer;
 R    : real;
 i    : integer;
begin
 R:=124;
 for i := 1 to t do
    R := R * step;
 Tone:=round(R);
 GetTone := Tone;
end;

Procedure ConvStrToMREC(s : string; var M : Mus_REC);
var
 i, j : integer;
 Octave : Byte;
 DL,CD : Word;
 NumExpected : boolean;
 Nm : string;
 Count : Word;

Procedure Add(Freq : word);
begin
   Inc(Count);
   if Count <= 256 then
   begin
      M.DATA[Count].Freq := Freq;
   end;
end;

begin
   count := 0;
   for i := 1 to length(s) do
     S[i] := UpCase(S[i]);
   S := S + ' ';
   Octave := 0;
   NumExpected := False;
   for i := 1 to Length(s) do
   begin
      if S[I] in Notes then
      begin
         if S[I+1] = '#' then
           ADD(GetTone(NotesValues[S[i]]+Octave*12+1))
          else
           ADD(GetTone(NotesValues[S[i]]+Octave*12));
         NumExpected := True;
         Nm := '';
      end
    else
      if (NumExpected) and (S[I] in Nums) then
      begin
         Nm := Nm+S[I];
         if not (S[I+1] in Nums) then
         begin
            DL := 0;
            Val(Nm,DL,Cd);
            M.DATA[Count].D := (DL*BRK);
            NumExpected := False;
         end;
      end
     else
      if S[I] in Signs then
      begin
         if (S[i] = '>') and (Octave < 6) then
           Inc(Octave);
         if (S[I] = '<') and (Octave > 0) then
           Dec(Octave);
         if (S[I] = '|') then
         begin
            Add(65000);
            Nm := '';
            NumExpected := True;
         end;
      end;
   end;
   M.Count := Count;
end;


Procedure MPlayer.UpDate;
begin
   if Playing then
   begin
      if Timer = 0 then
      begin
         if Counter < Music.Count then
         begin
            Inc(Counter);
            Sound(Music.DATA[Counter].Freq);
            Timer := Music.DATA[Counter].D;
         end
        else begin
                NoSound;
                Playing := False;
             end;
      end
    else
      Dec(Timer);
   end;
end;

Procedure MPlayer.Play(s : string);
begin
   Timer := 0;
   ConvStrToMREC(s,Music);
   Counter := 0;
   Playing := True;
end;

begin
   Brk := 1;
end.
