uses Crt, A_Grf, VGA2, Small_Ch, Music_U, BmpSVGA;

type
  Direction = (Up, Down, Right, Left);
  Dot = object
          x,y : integer;
          Procedure Reset;
          Procedure Assign(px,py : integer);
          Procedure Move(px,py : integer);
        end;

 TSnake = object
             Snake : Array[1..2304] of Dot;
             Count : Integer;
             D     : Direction;
             Timer : integer;
             STime : integer;
             Color : byte;
             Boom  : Boolean;
             Grow  : integer;
             Bonus : Dot;
             Score : Longint;
             Status: string;
             SBONUS: string;
             PrintS: string;
             PrintP: integer;
             PRTime: integer;
             PRTimr: integer;
             STTime: integer;
             Play  : boolean;
             Constructor Init(St, PColor : integer);
             Procedure Step;
             Function  CheckDot(PD : Dot) : Boolean;
             Procedure MoveWorm(NewPos : Dot);
             Procedure Draw;
             Procedure HandleKeys;
          end;

 FrameInfo = record
               x,sx : integer;
               DAT : Pointer;
             end;
   HighScoreRec = record
                     Name  : string[30];
                     Score : longint;
                  end;
   HSType = Array[1..8] of HighScoreRec;
var
 Mus : MPlayer;
 Pic : Pointer;
 HighScore : HSType;
 SnakeAni : Array[1..3] of FrameInfo;
 GrayWall230x160,
 Ball5x5,
 GameLevel_310x156,
 HighScoreBoard_248x135,
 HSName_228x25 : pointer;

Procedure LoadGraphix;
var
 F : file;
begin
   Assign(F,'GRAPHIX.DAT');
   Reset(F,1);

   GetMEM(GrayWall230x160,230*160);
   BlockRead(F,GrayWall230x160^,230*160);

   GetMEM(Ball5x5,5*5);
   BlockRead(F,Ball5x5^,5*5);

   GetMEM(SnakeAni[1].DAT,73*108);
   BlockRead(F,SnakeAni[1].DAT^,73*108);

   GetMEM(SnakeAni[2].DAT,73*108);
   BlockRead(F,SnakeAni[2].DAT^,73*108);

   GetMEM(SnakeAni[3].DAT,79*108);
   BlockRead(F,SnakeAni[3].DAT^,79*108);

   GetMEM(GameLevel_310x156,310*156);
   BlockRead(F,GameLevel_310x156^,310*156);

   GetMEM(HighScoreBoard_248x135,248*135);
   BlockRead(F,HighScoreBoard_248x135^,248*135);

   GetMEM(HSName_228x25,228*25);
   BlockRead(F,HSName_228x25^,228*25);
   Close(F);

   SnakeAni[1].X := 1; SnakeAni[1].SX := 73;
   SnakeAni[2].X := 1; SnakeAni[2].SX := 73;
   SnakeAni[3].X := -12; SnakeAni[3].SX := 79;
end;

Procedure DrawDot(PD : Dot; c : BYTE);
var
 x,y : integer;
begin
   x := ((PD.x-1)*5)+1;
   y := (19+((PD.y-1)*5))-1;
   Bar(x,y,x+4,y+4,C,VSAddr);
end;

Procedure DrawBonus(PD : Dot);
var
 x,y : integer;
begin
   x := ((PD.x-1)*5)+1;
   y := (19+((PD.y-1)*5))-1;
   PutIMG(Ball5x5,x,y,5,5,VSAddr);
end;


Function ClearNum(Num : LongInt) : String;
var
 S : String;
 C, J, I : Byte;
Begin
   Str(Num, S);
   if Length(S) > 3 then
   Begin
      C := 1;
      J := Length(S);
      for I := 1 to Length(S) do
      Begin
         Inc(C);
         J := J -1;
         if (C = 3) and (J > 1) then
         Begin
            Insert(',',S,J);
            C := 0;
         End;
      End;
   End;
   ClearNum := S;
End;


procedure WriteSmallChar (pY, pX : integer; color : byte; S : string);

var
   i,
   pos,
   loop1,
   loop2,
   delta  : byte;
 { Delta is uses to make the right space between characters. For example:
   after a normal character you make more space then after a '('.}
   Y,X : integer;
   dd : dot;
begin
   Y := pY;
   X := pX;
   for i := 1 to length (S) do
     S [i] := upcase (S [i]);   { Upcase the given string.}
   for i := 1 to length (S) do
   begin
      if S[i] in ['A'..'Z',' '] then
      begin
         pos := ord (S[i])-64;  { See 'Large_ch.pas' to see why this is.}
         if S[i] = ' ' then
            delta := 4          { 4 pixels space after a ' '.}
         else
            delta := 7          { 7 pixels space after a characters.}
      end
      else
      if S[i] in ['0'..'9'] then
      begin
         pos := ord (S[i])-21;  { See 'Large_ch.pas' to see why this is.}
         delta := 7
      end
      else
      case S[i] of
        '.' : begin
                 pos := 37;     { Pos referes to the position in the array of characters.}
                 delta := 5     { Here you see the different delta's.}
              end;
        ',' : begin
                 pos := 38;
                 delta := 2
              end;
        ':' : begin
                 pos := 39;
                 delta := 3
              end;
        '(' : begin
                 pos := 40;
                 delta := 5
              end;
        ')' : begin
                 pos := 41;
                 delta := 7
              end;
        '?' : begin
                 pos := 42;
                 delta := 2
              end;
        '/' : begin
                 pos := 43;
                 delta := 7
              end;
        '!' : begin
                 pos := 44;
                 delta := 4
              end
        end;
        if S[i] <> ' ' then
        begin
           for loop1 := 1 to 5 do
              for loop2 := 1 to 5 do
                 if SmallChars [pos,loop1,loop2] <> 0 then
                 begin
                    PutPixel(x+loop2,y+loop1,Color,VSAddr);
                 end;

        end;
           inc (X,delta) { Makes the space after the character.}
   end
end;



Constructor TSnake.Init(ST, PColor : integer);
var
 i : integer;
begin
   for i := 1 to 2304 do
     Snake[i].Reset;
   Count := 1;
   Snake[Count].Assign(32,18);
   D := Up;
   Timer := 0;
   STime := St;
   Color := PColor;
   Grow := 0;
   Bonus.Assign(Random(62)+2,Random(34)+2);
   SBONUS := '! PLAYING!';
   Status := SBONUS;
   Score := 0;
   PrintP := 0;
   PrintS := '';
   Play := False;
end;


{     Up_Key    : Char = #72;
      Down_Key  : Char = #80;
      Right_Key : Char = #77;
      Left_Key  : Char = #75;}

Procedure TSnake.HandleKeys;
var
 ch : char;
begin
   ch := readkey;
   if ch = #0 then
   begin
      ch := readkey;
      case ch of

           #72: if D <> Down then D := Up;
           #80: if D <> Up then D := Down;
           #77: if D <> left then D := Right;
           #75: if D <> right then D := Left;

      end;
   end;
   if ch = #27 then
     Boom := True;
end;

Procedure TSnake.Draw;
var
 i,j : integer;
 dd : dot;
begin
   Bar(0,18,317,198,8,VSAddr);
   Box(0,17,317,199,24,VSAddr);
   Bar(1,1,316,15,25,VSAddr);
   WriteSmallChar(10,2,8,'Score: '+ClearNum(Score));
   WriteSmallChar(2,160-(Length(Status)*4),8,Status);
   if play then
   begin
      for i := 1 to Count do
         DrawDot(Snake[i],7);
      DrawBonus(Bonus);
   end;
end;

Function TSnake.CheckDot(PD : Dot) : Boolean;
var
 i : integer;
begin
   CheckDot := True;
   for i := 1 to count do
     if (Snake[i].x = PD.x) and (Snake[i].y = PD.y) then
       CheckDot := False;
end;


Procedure TSnake.MoveWorm(NewPos : Dot);
var
 i : integer;
begin
   if Grow = 0 then
   begin
      for i := 1 to Count-1 do
        Snake[i] := Snake[i+1];
      Snake[Count] := NewPos;
   end
  else
   if grow > 0 then
   begin
     Dec(Grow);
     if Count < 2403 then
     begin
        Inc(Count);
        Snake[Count] := NewPos;
     end;
   end;
end;

Procedure TSnake.Step;
var
 P : Dot;
begin
   if PrTimr > 0 then
    dec(PrTimr)
   else
    begin
       if (PrintP > 0) then
       begin
          Status := Status+ PrintS[PrintP];
          Inc(PrintP);
          if not Mus.Playing then
            Mus.Play('>>>>C2');
       end;
       if PrintP > length(PrintS) then PrintP := 0;
       PrTimr := PrTime;
    end;

   if STTime > 0 then
      Dec(STTime)
    else
     Status := SBONUS;

   if (timer <> 0) then
   begin
      dec(Timer);
      exit;
   end
  else
   Timer := STime;
   if not play then
     Exit;
   if keypressed then
    HandleKeys;

   Case D of
       Up : begin
               P := Snake[Count];
               Dec(P.y);
               if (Snake[Count].Y > 1) and (CheckDot(P)) then
                  MoveWorm(P)
                else
                  Boom := True;
            end;

       Down : begin
                 P := Snake[Count];
                 Inc(P.y);
                 if (Snake[Count].Y < 36) and (CheckDot(P)) then
                    MoveWorm(P)
                  else
                    Boom := True;
              end;

       Right : begin
                  P := Snake[Count];
                  Inc(P.x);
                  if (Snake[Count].x < 63) and (CheckDot(P)) then
                     MoveWorm(P)
                   else
                     Boom := True;
               end;

       Left : begin
                 P := Snake[Count];
                 Dec(P.x);
                 if (Snake[Count].x > 1) and (CheckDot(P)) then
                    MoveWorm(P)
                  else
                    Boom := True;
              end;
   end;
   if not boom then
     if (P.x = Bonus.x) and (P.y = Bonus.y) then
     begin
        Grow := 10;
        Inc(Score,9-STime);
        STTime := 120;
        Status := 'GOOD FOR YOU!!!';
        if (printp = 0) and (not Mus.Playing) then Mus.Play('C5>>>>C5');
        repeat
           Bonus.Assign(Random(62)+2,Random(34)+2);
        until CheckDot(Bonus);
     end;

   if Boom then
   begin
      Status := 'Game Over!!!';
   end;

end;

Procedure Dot.Reset;
begin
   x := 0; y := 0;
end;

Procedure Dot.Assign(px,py : integer);
begin
   x := px; y := py;
end;

Procedure Dot.Move(px,py : integer);
begin
   x := x + px; y := y + py;
end;


var
  S     : TSnake;
  Level : integer;
  Done  : Boolean;
  Name  : String[30];

Procedure InitHighScore;
var
 i : integer;
 F : file of HSType;
begin
   Assign(F,'HIGHSCOR.TBL');
   {$I-}Reset(F);{$I+}
   if IOResult <> 0 then
      for i := 1 to 8 do
      begin
         HighScore[i].NAME := 'ANONYMOUS';
         HighScore[i].SCORE := 0;
      end
     else
      begin
         Read(F,HighScore);
         Close(F);
      end;
end;

Procedure DoneHighScore;
var
 i : integer;
 F : file of HSType;
begin
   Assign(F,'HIGHSCOR.TBL');
   {$I-}ReWrite(F);{$I+}
   if IOResult <> 0 then
      Writeln('Unable to access the file "HIGHSCOR.TBL"')
     else
      begin
         Write(F,HighScore);
         Close(F);
      end;
end;


Function CheckResult(score : longint) : byte;
var
 i : integer;
begin
   CheckResult := 0;
   if score < HighScore[8].score then
     Exit;
   for i := 1 to 8 do
     if score > HighScore[i].score then
     begin
        CheckResult := i;
        Break;
     end;
end;

Procedure InsertResult(name : string; score : longint; pos : byte);
var
 i : integer;
begin
   for i := 8 downto pos+1 do
     HighScore[i] := HighScore[i-1];
   HighScore[pos].name := name;
   HighScore[pos].score := score;
end;

Procedure DisplayHighScore;
var
 i : integer;
begin
  PutIMG(HighScoreBoard_248x135,35,25,248,135,VSAddr);
  for i := 0 to 7 do
  begin
     WriteSmallChar(84+(i*8),50,21,HighScore[i+1].NAME);
     WriteSmallChar(84+(i*8),230,21,ClearNum(HighScore[i+1].score));
  end;
end;

Procedure UpDateHighScore(Pos : integer);
var
 Dn    : boolean;
 Abort : boolean;
 Ch    : char;
 Curs  : byte;
begin
   Dn := False;
   Abort := False;
   S.SBonus := 'Enter your name please';
   Curs := Length(Name);
   repeat
     S.Step;
     S.Draw;
     DisplayHighScore;
     PutIMG(HSName_228x25,41,167,228,25,VSAddr);
     WriteSmallChar(176,140,21,NAME);
     PutIMG(Ball5x5,140+Curs*7,177,5,5,VSAddr);
     flip;
     WaitRetrace;
     Mus.UpDate;
     if keypressed then
     begin
        ch := readkey;
        Case ch of
            #0      : ch := readkey;
            #13     : if NAME <> '' then Dn := True;
            #27     : Abort := True;
            'A'..'Z': if Curs < 17 then begin
                         NAME := NAME + ch;
                         Inc(Curs);
                      end;
            'a'..'z': if Curs < 17 then begin
                         NAME := NAME + ch;
                         Inc(Curs);
                      end;
                 ' ': if Curs < 17 then begin
                         NAME := NAME + ch;
                         Inc(Curs);
                      end;
                 #8 : if Curs > 0 then begin
                         Delete(NAME,Length(NAME),1);
                         Dec(Curs);
                      end;
        end;
     end;
   until (Dn) or (Abort);
   if not Abort then InsertResult(NAME,S.Score,Pos);
end;

Procedure HighScoreScreen;
var
 pos : integer;
 ch  : char;
begin
   Cls(25,VSAddr);
   bar(318,0,319,199,0,VSAddr);
   Mus.Play('>>C6 C#6 C6 < A#6 G12 A#6 B#6 A#6 G#6 F12 G#6 A#6 G#6 G6 E12'+
            'G6 G#6 G6 F6 C#36 F6 C#6 G6 F6 A#6 > C#6 < B#6 G#6 E#6'+
            'G#6 G6 F6 E6 >C#6< B#6 A#6 G#6 G6 F12 >F6 |6 F6'
            );
   pos := CheckResult(S.Score);
   S.Play := False;
   S.STTime := 0;
   S.SBONUS := 'High score';
   if Pos > 0 then
     UpDateHighScore(Pos);
   ch := ' ';
   repeat
     S.Step;
     S.Draw;
     DisplayHighScore;
     flip;
     WaitRetrace;
     Mus.UpDate;
     if keypressed then ch := readkey;
     if ch = #0 then ch := readkey;
   until ((ch = #13)or(ch = #27));
end;

Procedure Init;
begin
   InitMCGA;
   Randomize;
   SetVisScr;
   LoadGraphix;
   Done := False;
   Level := 2;
   Name := '';
   InitHighScore;
end;

Procedure OpenGame;
var
 Counter : longint;
 Copyr   : integer;
 SnakeA  : Integer;
 CurrFrm : Byte;
 ch      : char;
begin
   S.Play := False;
   Counter := 0;
   Copyr := 0;
   S.SBONUS := '! Y.M.S  Gray Wall Snake!';
   Cls(25,VSAddr);
   bar(318,0,319,199,0,VSAddr);
   CurrFrm := 1;
   SnakeA := 0;
   repeat
     S.Step;
     S.Draw;
     PutImg(GrayWall230x160,10,30,230,160,VSAddr);
     PutIMG(SnakeAni[CurrFrm].DAT,SnakeAni[CurrFrm].x+230,50,
            SnakeAni[CurrFrm].sx,108,VSAddr);
     flip;
     WaitRetrace;
     Mus.UpDate;
     Inc(Counter);
     if counter = 50 then
     begin
        Mus.Play('>C4D4E4F4G4A4B4>C20 |10 < G20 |10 G#20 |10 F20 |10 G20 |3'+
                 'F8D#8 |5 D8 |5 C40'
                );
     end;
     if Copyr = 300 then
     begin
        S.Status := '';
        S.PrintS := 'PRESS ANY KEY TO PLAY!!!';
        S.PrintP := 1;
        S.PrTimr := 0;
        S.PrTime := 3;
        S.STTime := 150;
        Copyr := 0;
     end
    else
     Inc(Copyr);
     if SnakeA = 0 then
     begin
        CurrFrm := Random(3)+1;
        SnakeA := Random(40)+40;
     end
    else
     Dec(SnakeA);
   until KeyPressed;
   ch := readkey;
   if ch = #27 then done := true;
   while keypressed do readkey;
end;

Function GameLevel : boolean;
var
 ch : char;
 CurrS : integer;
Const
  Poss : Array[1..9] of integer = (12,42,96,115,142,180,217,260,283);
begin
   S.SBONUS := 'Game Level Setting';
   S.STTime := 0;
   S.PrintP := 0;
   CurrS := 9-level;
   Ch := ' ';
   repeat
     S.Step;
     S.Draw;
     PutIMG(GameLevel_310x156,3,30,310,156,VSAddr);
     PutIMG(Ball5x5,Poss[CurrS],190,5,5,VSAddr);
     flip;
     WaitRetrace;
     Mus.UpDate;
     if keypressed then
      Ch := readkey;
     if Ch = #0 then
     begin
        Ch := Readkey;
        case CH of

           #77 : if CurrS < 9 then Inc(CurrS);
           #75 : if CurrS > 1 then Dec(CurrS);

        end;
        case CurrS of
            1 : S.SBONUS := '1 point each (very slow...)';
            2 : S.SBONUS := '2 points each (very slow)';
            3 : S.SBONUS := '3 points each (very slow)';
            4 : S.SBONUS := '4 points each (slow)';
            5 : S.SBONUS := '5 points each (slow)';
            6 : S.SBONUS := '6 points each (normal)';
            7 : S.SBONUS := '7 points each (fine)';
            8 : S.SBONUS := '8 points each (fast)';
            9 : S.SBONUS := '9 points each (really fast!!)';
        end;
     end;
   until (ch = #13) or (ch = #27);
   Level := 9-CurrS;
   if ch = #27 then
     GameLevel := False
    else
     GameLevel := True;
end;


Procedure PlayGame;
begin
   S.Init(Level,1);
   S.Boom := false;
   S.Play := True;
   S.SBONUS := '! PLAYING!';
   S.STTime := 0;
   S.PrintP := 0;
   repeat
     S.Step;
     S.Draw;
     flip;
     WaitRetrace;
     Mus.UpDate;
   until s.Boom;
end;

Procedure DoneGame;
begin
   NoSound;
   TextMode(CO80);
   DoneHighScore;
end;

begin
   Init;
   repeat
     OpenGame;
     if not done then
     begin
        if GameLevel then
        begin
           PlayGame;
           HighScoreScreen;
        end;
     end;
   until done;
   DoneGame;
end.
